diff --git a/pki/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java b/pki/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
index a384436445015d2e9e7ce26aee28b199fb079e90..e3ecdb33d49b1dcdc4612996117be56190f972f3 100644
--- a/pki/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
+++ b/pki/base/util/src/netscape/security/x509/PrivateKeyUsageExtension.java
@@ -322,7 +322,7 @@ public class PrivateKeyUsageExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NOT_BEFORE);
         elements.addElement(NOT_AFTER);
diff --git a/pki/base/util/src/netscape/security/x509/RevokedCertImpl.java b/pki/base/util/src/netscape/security/x509/RevokedCertImpl.java
index 3271768f7925dd328d3717cd9b9ddbb6de65a400..345694fb1d84b77d43b4b179aa7f51064bd9560e 100755
--- a/pki/base/util/src/netscape/security/x509/RevokedCertImpl.java
+++ b/pki/base/util/src/netscape/security/x509/RevokedCertImpl.java
@@ -66,13 +66,13 @@ import netscape.security.util.ObjectIdentifier;
  * @version 1.6 97/12/10
  */
 
-public class RevokedCertImpl extends RevokedCertificate
-        implements Serializable {
+public class RevokedCertImpl extends RevokedCertificate implements Serializable {
 
     /**
      *
      */
     private static final long serialVersionUID = -3449642360223397701L;
+
     private SerialNumber serialNumber;
     private Date revocationDate;
     private CRLExtensions extensions = null;
@@ -86,11 +86,13 @@ public class RevokedCertImpl extends RevokedCertificate
     }
 
     /**
-     * Constructs a revoked certificate entry using the
-     * serial number and revocation date.
+     * Constructs a revoked certificate entry using the serial number and
+     * revocation date.
      * 
-     * @param num the serial number of the revoked certificate.
-     * @param date the Date on which revocation took place.
+     * @param num
+     *            the serial number of the revoked certificate.
+     * @param date
+     *            the Date on which revocation took place.
      */
     public RevokedCertImpl(BigInteger num, Date date) {
         this.serialNumber = new SerialNumber(num);
@@ -98,16 +100,17 @@ public class RevokedCertImpl extends RevokedCertificate
     }
 
     /**
-     * Constructs a revoked certificate entry using the
-     * serial number, revocation date and the entry
-     * extensions.
+     * Constructs a revoked certificate entry using the serial number,
+     * revocation date and the entry extensions.
      * 
-     * @param num the serial number of the revoked certificate.
-     * @param date the Date on which revocation took place.
-     * @param crlEntryExts the extensions for this entry.
+     * @param num
+     *            the serial number of the revoked certificate.
+     * @param date
+     *            the Date on which revocation took place.
+     * @param crlEntryExts
+     *            the extensions for this entry.
      */
-    public RevokedCertImpl(BigInteger num, Date date,
-                           CRLExtensions crlEntryExts) {
+    public RevokedCertImpl(BigInteger num, Date date, CRLExtensions crlEntryExts) {
         this.serialNumber = new SerialNumber(num);
         this.revocationDate = date;
         this.extensions = crlEntryExts;
@@ -120,7 +123,7 @@ public class RevokedCertImpl extends RevokedCertificate
             try {
                 encode(os);
             } catch (Exception e) {
-                //	revokedCert = null;
+                // revokedCert = null;
             }
             revokedCert = os.toByteArray();
         }
@@ -135,7 +138,8 @@ public class RevokedCertImpl extends RevokedCertificate
     /**
      * Sets extensions for this impl.
      * 
-     * @param crlEntryExts CRLExtensions
+     * @param crlEntryExts
+     *            CRLExtensions
      */
     public void setExtensions(CRLExtensions crlEntryExts) {
         this.extensions = crlEntryExts;
@@ -144,12 +148,15 @@ public class RevokedCertImpl extends RevokedCertificate
     /**
      * Unmarshals a revoked certificate from its encoded form.
      * 
-     * @param revokedCert the encoded bytes.
-     * @exception CRLException on parsing errors.
-     * @exception X509ExtensionException on extension handling errors.
+     * @param revokedCert
+     *            the encoded bytes.
+     * @exception CRLException
+     *                on parsing errors.
+     * @exception X509ExtensionException
+     *                on extension handling errors.
      */
-    public RevokedCertImpl(byte[] revokedCert)
-            throws CRLException, X509ExtensionException {
+    public RevokedCertImpl(byte[] revokedCert) throws CRLException,
+            X509ExtensionException {
         try {
             DerValue derValue = new DerValue(revokedCert);
             parse(derValue);
@@ -161,21 +168,23 @@ public class RevokedCertImpl extends RevokedCertificate
     /**
      * Unmarshals a revoked certificate from its encoded form.
      * 
-     * @param derValue the DER value containing the revoked certificate.
-     * @exception CRLException on parsing errors.
-     * @exception X509ExtensionException on extension handling errors.
+     * @param derValue
+     *            the DER value containing the revoked certificate.
+     * @exception CRLException
+     *                on parsing errors.
+     * @exception X509ExtensionException
+     *                on extension handling errors.
      */
-    public RevokedCertImpl(DerValue derValue)
-            throws CRLException, X509ExtensionException {
+    public RevokedCertImpl(DerValue derValue) throws CRLException,
+            X509ExtensionException {
         parse(derValue);
     }
 
     /**
-     * Returns true if this revoked certificate entry has
-     * extensions, otherwise false.
+     * Returns true if this revoked certificate entry has extensions, otherwise
+     * false.
      * 
-     * @return true if this CRL entry has extensions, otherwise
-     *         false.
+     * @return true if this CRL entry has extensions, otherwise false.
      */
     public boolean hasExtensions() {
         if (extensions == null)
@@ -187,13 +196,15 @@ public class RevokedCertImpl extends RevokedCertificate
     /**
      * Decode a revoked certificate from an input stream.
      * 
-     * @param inStrm an input stream holding at least one revoked
-     *            certificate
-     * @exception CRLException on parsing errors.
-     * @exception X509ExtensionException on extension handling errors.
+     * @param inStrm
+     *            an input stream holding at least one revoked certificate
+     * @exception CRLException
+     *                on parsing errors.
+     * @exception X509ExtensionException
+     *                on extension handling errors.
      */
-    public void decode(InputStream inStrm)
-            throws CRLException, X509ExtensionException {
+    public void decode(InputStream inStrm) throws CRLException,
+            X509ExtensionException {
         try {
             DerValue derValue = new DerValue(inStrm);
             parse(derValue);
@@ -205,13 +216,16 @@ public class RevokedCertImpl extends RevokedCertificate
     /**
      * Encodes the revoked certificate to an output stream.
      * 
-     * @param outStrm an output stream to which the encoded revoked
-     *            certificate is written.
-     * @exception CRLException on encoding errors.
-     * @exception X509ExtensionException on extension handling errors.
+     * @param outStrm
+     *            an output stream to which the encoded revoked certificate is
+     *            written.
+     * @exception CRLException
+     *                on encoding errors.
+     * @exception X509ExtensionException
+     *                on extension handling errors.
      */
-    public void encode(DerOutputStream outStrm)
-            throws CRLException, X509ExtensionException {
+    public void encode(DerOutputStream outStrm) throws CRLException,
+            X509ExtensionException {
         try {
             if (revokedCert == null) {
                 DerOutputStream tmp = new DerOutputStream();
@@ -236,8 +250,7 @@ public class RevokedCertImpl extends RevokedCertificate
     }
 
     /**
-     * Gets the serial number for this RevokedCertificate,
-     * the <em>userCertificate</em>.
+     * Gets the serial number for this RevokedCertificate, the <em>userCertificate</em>.
      * 
      * @return the serial number.
      */
@@ -246,8 +259,7 @@ public class RevokedCertImpl extends RevokedCertificate
     }
 
     /**
-     * Gets the revocation date for this RevokedCertificate,
-     * the <em>revocationDate</em>.
+     * Gets the revocation date for this RevokedCertificate, the <em>revocationDate</em>.
      * 
      * @return the revocation date.
      */
@@ -277,8 +289,8 @@ public class RevokedCertImpl extends RevokedCertificate
         if (extensions != null) {
             sb.append("\n");
             for (int i = 0; i < extensions.size(); i++)
-                sb.append("Entry Extension[" + i + "]: " +
-                        ((Extension) (extensions.elementAt(i))).toString());
+                sb.append("Entry Extension[" + i + "]: "
+                        + ((Extension) (extensions.elementAt(i))).toString());
         }
         sb.append("\n");
         return (sb.toString());
@@ -299,7 +311,7 @@ public class RevokedCertImpl extends RevokedCertificate
         for (Enumeration<Extension> e = extensions.getElements(); e.hasMoreElements();) {
             ex = e.nextElement();
             if (ex.isCritical())
-                extSet.add(((ObjectIdentifier) ex.getExtensionId()).toString());
+                extSet.add(ex.getExtensionId().toString());
         }
         return extSet;
     }
@@ -317,9 +329,9 @@ public class RevokedCertImpl extends RevokedCertificate
         Set<String> extSet = new LinkedHashSet<String>();
         Extension ex;
         for (Enumeration<Extension> e = extensions.getElements(); e.hasMoreElements();) {
-            ex = (Extension) e.nextElement();
+            ex = e.nextElement();
             if (!ex.isCritical())
-                extSet.add(((ObjectIdentifier) ex.getExtensionId()).toString());
+                extSet.add(ex.getExtensionId().toString());
         }
         return extSet;
     }
@@ -348,7 +360,7 @@ public class RevokedCertImpl extends RevokedCertificate
                 Extension ex = null;
                 ObjectIdentifier inCertOID;
                 for (Enumeration<Extension> e = extensions.getElements(); e.hasMoreElements();) {
-                    ex = (Extension) e.nextElement();
+                    ex = e.nextElement();
                     inCertOID = ex.getExtensionId();
                     if (inCertOID.equals(findOID)) {
                         crlExt = ex;
@@ -419,10 +431,9 @@ public class RevokedCertImpl extends RevokedCertificate
     }
 
     /**
-     * Serialization write ... X.509 certificates serialize as
-     * themselves, and they're parsed when they get read back.
-     * (Actually they serialize as some type data from the
-     * serialization subsystem, then the cert data.)
+     * Serialization write ... X.509 certificates serialize as themselves, and
+     * they're parsed when they get read back. (Actually they serialize as some
+     * type data from the serialization subsystem, then the cert data.)
      */
     private synchronized void writeObject(ObjectOutputStream stream)
             throws CRLException, X509ExtensionException, IOException {
@@ -432,8 +443,8 @@ public class RevokedCertImpl extends RevokedCertificate
     }
 
     /**
-     * Serialization read ... X.509 certificates serialize as
-     * themselves, and they're parsed when they get read back.
+     * Serialization read ... X.509 certificates serialize as themselves, and
+     * they're parsed when they get read back.
      */
     private synchronized void readObject(ObjectInputStream stream)
             throws CRLException, X509ExtensionException, IOException {
diff --git a/pki/base/util/src/netscape/security/x509/RevokedCertificate.java b/pki/base/util/src/netscape/security/x509/RevokedCertificate.java
index 64eed427e51579f82185e71884f890d96a1c02bd..2087d064ae272379d85ec84d3b3a3491c5a51dbe 100644
--- a/pki/base/util/src/netscape/security/x509/RevokedCertificate.java
+++ b/pki/base/util/src/netscape/security/x509/RevokedCertificate.java
@@ -89,4 +89,7 @@ public abstract class RevokedCertificate extends X509CRLEntry {
      * @return a string representation of this revoked certificate.
      */
     public abstract String toString();
+
+    public abstract CRLExtensions getExtensions();
+
 }
diff --git a/pki/base/util/src/netscape/security/x509/SubjectAlternativeNameExtension.java b/pki/base/util/src/netscape/security/x509/SubjectAlternativeNameExtension.java
index 779503e60dc3995ae5bf2af236e377130d0098af..c30ae15761b388cb5cb5adb8ac4a9c5588c6150f 100644
--- a/pki/base/util/src/netscape/security/x509/SubjectAlternativeNameExtension.java
+++ b/pki/base/util/src/netscape/security/x509/SubjectAlternativeNameExtension.java
@@ -226,7 +226,7 @@ public class SubjectAlternativeNameExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(SUBJECT_NAME);
 
diff --git a/pki/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java b/pki/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
index 40e7a3f0d937b728809023e7270e5f42151d539f..b249ef6005485dd28af4d72f7e1ebff98bb705c4 100644
--- a/pki/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
+++ b/pki/base/util/src/netscape/security/x509/SubjectDirAttributesExtension.java
@@ -263,7 +263,7 @@ public class SubjectDirAttributesExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         return (elements.elements());
     }
diff --git a/pki/base/util/src/netscape/security/x509/SubjectKeyIdentifierExtension.java b/pki/base/util/src/netscape/security/x509/SubjectKeyIdentifierExtension.java
index fd22b20f02baf55dea1478610893ff97977d1c98..ea0ebae82328e9e19591a89f96ba3efe42c74723 100644
--- a/pki/base/util/src/netscape/security/x509/SubjectKeyIdentifierExtension.java
+++ b/pki/base/util/src/netscape/security/x509/SubjectKeyIdentifierExtension.java
@@ -206,7 +206,7 @@ public class SubjectKeyIdentifierExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(KEY_ID);
 
diff --git a/pki/base/util/src/netscape/security/x509/X500NameAttrMap.java b/pki/base/util/src/netscape/security/x509/X500NameAttrMap.java
index aac89e21a87747ba47d563e45e75906990063d42..1c87c79b840f82c5a1cd50e1ba7c3a956e5debd3 100644
--- a/pki/base/util/src/netscape/security/x509/X500NameAttrMap.java
+++ b/pki/base/util/src/netscape/security/x509/X500NameAttrMap.java
@@ -206,7 +206,8 @@ public class X500NameAttrMap {
 
     Hashtable<String, ObjectIdentifier> name2OID = new Hashtable<String, ObjectIdentifier>();
     Hashtable<ObjectIdentifier, String> oid2Name = new Hashtable<ObjectIdentifier, String>();
-    Hashtable<ObjectIdentifier, AVAValueConverter> oid2ValueConverter = new Hashtable<ObjectIdentifier, AVAValueConverter>();
+    Hashtable<ObjectIdentifier, AVAValueConverter> oid2ValueConverter =
+            new Hashtable<ObjectIdentifier, AVAValueConverter>();
 
     //
     // global defaults.
diff --git a/pki/base/util/src/netscape/security/x509/X509CertImpl.java b/pki/base/util/src/netscape/security/x509/X509CertImpl.java
index 3600287347a9d13105579ccb563fa8519757d208..d2d77cb3a77f2ffda9da77c584c36862f430f6da 100755
--- a/pki/base/util/src/netscape/security/x509/X509CertImpl.java
+++ b/pki/base/util/src/netscape/security/x509/X509CertImpl.java
@@ -912,8 +912,8 @@ public class X509CertImpl extends X509Certificate
                 return null;
             Set<String> extSet = new LinkedHashSet<String>();
             Extension ex;
-            for (Enumeration e = exts.getElements(); e.hasMoreElements();) {
-                ex = (Extension) e.nextElement();
+            for (Enumeration<Extension> e = exts.getAttributes(); e.hasMoreElements();) {
+                ex = e.nextElement();
                 if (ex.isCritical())
                     extSet.add(((ObjectIdentifier) ex.getExtensionId()).toString());
             }
@@ -941,8 +941,8 @@ public class X509CertImpl extends X509Certificate
 
             Set<String> extSet = new LinkedHashSet<String>();
             Extension ex;
-            for (Enumeration e = exts.getElements(); e.hasMoreElements();) {
-                ex = (Extension) e.nextElement();
+            for (Enumeration<Extension> e = exts.getAttributes(); e.hasMoreElements();) {
+                ex = e.nextElement();
                 if (!ex.isCritical())
                     extSet.add(((ObjectIdentifier) ex.getExtensionId()).toString());
             }
@@ -962,8 +962,8 @@ public class X509CertImpl extends X509Certificate
             Extension ex = null;
             ;
             ObjectIdentifier inCertOID;
-            for (Enumeration e = exts.getElements(); e.hasMoreElements();) {
-                ex = (Extension) e.nextElement();
+            for (Enumeration<Extension> e = exts.getAttributes(); e.hasMoreElements();) {
+                ex = e.nextElement();
                 inCertOID = ex.getExtensionId();
                 if (inCertOID.equals(findOID)) {
                     return ex;
@@ -996,8 +996,8 @@ public class X509CertImpl extends X509Certificate
                 Extension ex = null;
                 ;
                 ObjectIdentifier inCertOID;
-                for (Enumeration e = exts.getElements(); e.hasMoreElements();) {
-                    ex = (Extension) e.nextElement();
+                for (Enumeration<Extension> e = exts.getAttributes(); e.hasMoreElements();) {
+                    ex = e.nextElement();
                     inCertOID = ex.getExtensionId();
                     if (inCertOID.equals(findOID)) {
                         certExt = ex;
diff --git a/pki/base/util/src/netscape/security/x509/X509CertInfo.java b/pki/base/util/src/netscape/security/x509/X509CertInfo.java
index 9dd43de3fce0b961ce1b9cd2e7d45de8266068cf..4777cd9588d8700447574776a916417cf3f63540 100644
--- a/pki/base/util/src/netscape/security/x509/X509CertInfo.java
+++ b/pki/base/util/src/netscape/security/x509/X509CertInfo.java
@@ -223,7 +223,7 @@ public class X509CertInfo implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(VERSION);
         elements.addElement(SERIAL_NUMBER);
diff --git a/pki/base/util/test/com/netscape/security/extensions/GenericASN1ExtensionTest.java b/pki/base/util/test/com/netscape/security/extensions/GenericASN1ExtensionTest.java
new file mode 100644
index 0000000000000000000000000000000000000000..74d082f099b8ceb745b40c39cdc338f0b02c1555
--- /dev/null
+++ b/pki/base/util/test/com/netscape/security/extensions/GenericASN1ExtensionTest.java
@@ -0,0 +1,72 @@
+package com.netscape.security.extensions;
+
+import java.io.ByteArrayOutputStream;
+import java.io.OutputStream;
+import java.util.Hashtable;
+
+import netscape.security.extensions.GenericASN1Extension;
+import netscape.security.x509.OIDMap;
+
+import org.junit.Assert;
+import org.junit.Test;
+
+public class GenericASN1ExtensionTest {
+
+    //@Test
+    public void testConstructorArgs() throws Exception {
+        String name1 = "testExtension1";
+        String oid1 = "1.2.3.4";
+        String pattern = "";
+        Hashtable<String, String> config = new Hashtable<String, String>();
+        GenericASN1Extension extension1 = new GenericASN1Extension(name1, oid1,
+                pattern, false, config);
+        Assert.assertEquals(name1, extension1.getName());
+        Assert.assertNotNull(OIDMap.getClass(name1));
+
+        String name2 = "testExtension2";
+        String oid2 = "2.4.6.8";
+        GenericASN1Extension extension2 = new GenericASN1Extension(name2, oid2,
+                pattern, false, config);
+        Assert.assertEquals(name2, extension2.getName());
+        Assert.assertNotNull(OIDMap.getClass(name2));
+    }
+
+    @Test
+    public void testConstructorJustConfig() throws Exception {
+        String name1 = "testExtension1";
+        String oid1 = "1.2.3.4";
+        String pattern = "";
+        Hashtable<String, String> config = new Hashtable<String, String>();
+        config.put("oid", oid1);
+        config.put("name", name1);
+        config.put("pattern", pattern);
+        config.put("critical", "true");
+
+        GenericASN1Extension extension1 = new GenericASN1Extension(config);
+        Assert.assertEquals(name1, extension1.getName());
+        //Assert.assertNotNull(OIDMap.getClass(name1));
+
+        String name2 = "testExtension2";
+        String oid2 = "2.4.6.8";
+        config.put("oid", oid2);
+        config.put("name", name2);
+
+        GenericASN1Extension extension2 = new GenericASN1Extension(config);
+        Assert.assertEquals(name2, extension2.getName());
+        //Assert.assertNotNull(OIDMap.getClass(name2));
+        OutputStream outputStream = new ByteArrayOutputStream();
+        extension1.encode(outputStream);
+        extension2.encode(outputStream);
+
+    }
+
+    @Test
+    public void testConstructorDER() throws Exception {
+        byte[] value = new byte[0];
+        GenericASN1Extension extension = new GenericASN1Extension(true, value);
+
+        OutputStream outputStream = new ByteArrayOutputStream();
+        extension.encode(outputStream);
+
+    }
+}
-- 
1.7.5.1

